/*
 * Basic user types
 */
#ifndef UTYPE_H
#define UTYPE_H

// Boolean defs
#define TRUE 1
#define FALSE 0

// Misc function macros
#define MIN(x,y) ( (x) < (y) ? (x) : (y))
#define MAX(x,y) ( (x) < (y) ? (y) : (x))

// Basic types
typedef unsigned uint;
typedef float INTVAL;
typedef unsigned char BYTE;
typedef int BOOL;
typedef unsigned int KJCHAR;
typedef unsigned short ushort;

// Numbers
typedef struct {
  INTVAL value;
  int units;
} NUMBER;
typedef NUMBER PRESET;
typedef NUMBER ACTUAL;

// Pointers to functions
typedef void * FUNCDATA;
typedef void (*FUNC)();

// Language text
typedef char CTEXT;
typedef CTEXT *PTEXT;
typedef PTEXT TEXT[];

// Modify values
typedef struct {
    int value; /* value */
    int  limit; /* Limit */
} MODIFY;

#endif /* UTYPE_H */
